	cpu LMM
	.module nonvolatile.c
	.area text(rom, con, rel)
	.dbfile ./nonvolatile.c
	.dbfunc e Flash_ModifyBlk _Flash_ModifyBlk fc
;         Result -> X+0
;    Temperature -> X-9
;         Length -> X-8
;            src -> X-7
;      BlkOffset -> X-5
;       FlashBlk -> X-4
_Flash_ModifyBlk::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 33
; //----------------------------------------------------------------------------
; //
; //       FILENAME: NonVolatile.c
; //
; //    DESCRIPTION: Non Volatile Flash memory functions
; //
; //  LAST MODIFIED: Oct 23, 2006
; //
; //-----------------------------------------------------------------------------
; // Originally authored by Toradex AG. This work is now available under the terms and conditions
; // of the Creative Commons License 'Attribution CC BY', details of which can be found here:
; // http://creativecommons.org/licenses/by/3.0/
; //----------------------------------------------------------------------------
; #define __DEBUG__
; #include <m8c.h>        // part specific constants and macros
; #include "flashtemp.h"	// Measuring the Flash temperature Peter
; #include "flashblock.h"	// Cypress API for reading and writing flash blocks
; #include "PSoCDynamic.h"	//Dynamic Load of Configurations
; 
; BYTE				RWBuf[66];	// holds the Flash Block for modification
; FLASH_WRITE_STRUCT	fwStruct;
; FLASH_READ_STRUCT	frStruct;
; //-----------------------------------------------------------------------------
; // Modify Flash contents within a single flash block
; //	- Temperature (in C) is necessary for Flash programming. 
; //	  Accuracy of +-25C is sufficient
; //  - return value is 0 if operation there was an error
; //
; // NOTE: edit "flashsecurity.txt" to ensure the modified flash block is
; //       not write-protected!
; //-----------------------------------------------------------------------------
; BYTE Flash_ModifyBlk (BYTE FlashBlk, BYTE BlkOffset, BYTE *src, BYTE Length, BYTE Temperature)
; {
	.dbline 54
; 	BYTE Result;
; #ifdef __DEBUG
; 	// fill remaining stack with 0xAA (to test for stack overflow)
; 	asm (
; 		"PUSH	X		\n"
; 		"PUSH	A		\n"
; 		
; 		"MOV	X, SP	\n"
; 		"INC	X		\n"
; 		"MOV	A, 0xAA	\n"
; 	".LOOP:				\n"
; 		"MOV	[X], A	\n"
; 		"INC	X		\n"		
; 		"JNZ	.LOOP	\n"
; 
; 		"POP	A		\n"
; 		"POP	X		\n"
; 		);
; #endif		
; 	// Range check for "BlkOffset" and "Length" parameter
; 	if ( (BlkOffset + Length) >64)
	mov REG[0xd0],>__r0
	mov A,[X-5]
	add A,[X-8]
	mov [__r0],A
	mov A,64
	cmp A,[__r0]
	jnc L4
X0:
	.dbline 55
; 		return 0;
	mov REG[0xd0],>__r0
	mov A,0
	xjmp L3
L4:
	.dbline 58
; 	
; 	// Read complete Flash Block into RAM buffer
; 	frStruct.wARG_BlockId     = FlashBlk;
	mov A,[X-4]
	push A
	mov REG[0xd0],>_frStruct
	mov [_frStruct],0
	pop A
	mov [_frStruct+1],A
	.dbline 59
; 	frStruct.pARG_FlashBuffer = RWBuf;
	mov [_frStruct+2+1],<_RWBuf
	mov [_frStruct+2],>_RWBuf
	.dbline 60
; 	frStruct.wARG_ReadCount   = 64;
	mov [_frStruct+4+1],64
	mov [_frStruct+4],0
	.dbline 61
; 	FlashReadBlock( &frStruct );
	push X
	mov A,>_frStruct
	push A
	mov A,<_frStruct
	mov X,A
	pop A
	xcall _FlashReadBlock
	pop X
	xjmp L9
L8:
	.dbline 65
	.dbline 66
	mov REG[0xd0],>__r0
	mov A,[X-6]
	mov [__r1],A
	mov A,[X-7]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mov A,[X-5]
	mov [__r3],A
	mov [__r2],0
	add [__r3],<_RWBuf
	adc [__r2],>_RWBuf
	mov A,[__r2]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 68
	dec [X-8]
	.dbline 69
	inc [X-6]
	adc [X-7],0
	.dbline 70
	inc [X-5]
	.dbline 71
L9:
	.dbline 64
; 	
; 	// ---- change Flash contents in RAM
; 	while (Length > 0)
	mov A,0
	cmp A,[X-8]
	jc L8
X1:
	.dbline 74
; 	{
; 		RWBuf[BlkOffset] = *src;
; 		
; 		Length--;
; 		src++;
; 		BlkOffset++;
; 	}
; 
; 	// ---- write Flash block back into FLASH
; 	fwStruct.wARG_BlockId     = FlashBlk;
	mov A,[X-4]
	push A
	mov REG[0xd0],>_fwStruct
	mov [_fwStruct],0
	pop A
	mov [_fwStruct+1],A
	.dbline 75
; 	fwStruct.pARG_FlashBuffer = RWBuf;
	mov [_fwStruct+2+1],<_RWBuf
	mov [_fwStruct+2],>_RWBuf
	.dbline 76
; 	fwStruct.cARG_Temperature = Temperature;  
	mov A,[X-9]
	mov [_fwStruct+4],A
	.dbline 78
; #ifdef __DEBUG__
; M8C_DisableGInt;
		and F, FEh

	.dbline 80
; #endif
; 	Result = bFlashWriteBlock( &fwStruct );
	push X
	mov A,>_fwStruct
	push A
	mov A,<_fwStruct
	mov X,A
	pop A
	xcall _bFlashWriteBlock
	mov REG[0xd0],>__r0
	pop X
	mov [X+0],A
	.dbline 82
; #ifdef __DEBUG__
; M8C_EnableGInt;
		or  F, 01h

	.dbline 85
; #endif
; 
; 	return Result;
	mov A,[X+0]
	.dbline -2
L3:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l Result 0 c
	.dbsym l Temperature -9 c
	.dbsym l Length -8 c
	.dbsym l src -7 pc
	.dbsym l BlkOffset -5 c
	.dbsym l FlashBlk -4 c
	.dbend
	.dbfunc e Flash_Modify _Flash_Modify fc
;    Temperature -> X+5
;   FlashBlk_End -> X+4
;         Result -> X+3
;      BlkOffset -> X+2
;       FlashBlk -> X+1
;       WrLength -> X+0
;         length -> X-8
;            src -> X-7
;           dest -> X-5
_Flash_Modify::
	.dbline -1
	push X
	mov X,SP
	add SP,6
	.dbline 95
; }
; 
; 
; //-----------------------------------------------------------------------------
; // change Flash memory content
; //  - data may be split across multiple flash blocks (a block is 64 Bytes)
; //  - return value is 0 if there was an error
; //-----------------------------------------------------------------------------
; BYTE Flash_Modify (const BYTE *dest, BYTE *src, BYTE length)
; {
	.dbline 101
; 	BYTE	FlashBlk, FlashBlk_End, BlkOffset;
; 	BYTE	WrLength;
; 	BYTE	Result;
; 	char	Temperature;
; 	
; 	LoadConfig_FlashTmp_Config();
	xcall _LoadConfig_FlashTmp_Config
	.dbline 103
; 	// ----- update Flash temperature	Peter
; 	FlashTemp_Start();
	push X
	xcall _FlashTemp_Start
	pop X
L14:
	.dbline 104
L15:
	.dbline 104
; 	while (!FlashTemp_fIsData());
	push X
	xcall _FlashTemp_fIsData
	mov REG[0xd0],>__r0
	pop X
	cmp A,0
	jz L14
	.dbline 105
; 	Temperature = FlashTemp_cGetData();
	push X
	xcall _FlashTemp_cGetData
	mov REG[0xd0],>__r0
	pop X
	mov [X+5],A
	.dbline 107
; 	//Temperature = 25; //Estimated temperature in Toradex office
; 	FlashTemp_Stop();
	push X
	xcall _FlashTemp_Stop
	pop X
	.dbline 108
; 	UnloadConfig_FlashTmp_Config();
	xcall _UnloadConfig_FlashTmp_Config
	.dbline 112
; 	
; 	
; 	// ----- calculate Block and offset
; 	FlashBlk       = ( (WORD)dest << 2 ) /256;
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov A,[X-5]
	mov [__r0],A
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	mov A,[__r0]
	mov [X+1],A
	.dbline 113
; 	FlashBlk_End   = ( (WORD)(dest+length-1) << 2 ) /256;
	mov A,[X-8]
	mov [__r1],A
	mov [__r0],0
	mov A,[X-4]
	add [__r1],A
	mov A,[X-5]
	adc [__r0],A
	add [__r1],-1
	adc [__r0],-1
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	mov A,[__r0]
	mov [X+4],A
	.dbline 114
; 	BlkOffset      = (WORD)dest & 0x3F;
	mov A,[X-4]
	and A,63
	mov [X+2],A
	xjmp L18
L17:
	.dbline 118
; 	
; 	// ----- loop once for every flash block to modify
; 	while (length > 0)  
; 	{
	.dbline 120
; 		// -- adapt length if this is not the last block
; 		if (FlashBlk < FlashBlk_End)
	mov A,[X+1]
	cmp A,[X+4]
	jnc L20
X2:
	.dbline 121
; 			WrLength = 64 - BlkOffset;
	mov REG[0xd0],>__r0
	mov A,64
	sub A,[X+2]
	mov [X+0],A
	xjmp L21
L20:
	.dbline 123
; 		else
; 			WrLength = length;
	mov A,[X-8]
	mov [X+0],A
L21:
	.dbline 126
; 		
; 		// -- change flash
; 		Result = Flash_ModifyBlk (FlashBlk, BlkOffset, src, WrLength, Temperature);
	mov A,[X+5]
	push A
	mov A,[X+0]
	push A
	mov A,[X-7]
	push A
	mov A,[X-6]
	push A
	mov A,[X+2]
	push A
	mov A,[X+1]
	push A
	xcall _Flash_ModifyBlk
	add SP,-6
	mov REG[0xd0],>__r0
	mov [X+3],A
	.dbline 127
; 		if (Result == 0)
	cmp [X+3],0
	jnz L22
	.dbline 128
; 			return 0;	// error occured
	mov A,0
	xjmp L13
L22:
	.dbline 131
	mov REG[0xd0],>__r0
	mov A,[X+0]
	add A,[X-6]
	mov [X-6],A
	mov A,0
	adc A,[X-7]
	mov [X-7],A
	.dbline 132
	mov A,[X-8]
	sub A,[X+0]
	mov [X-8],A
	.dbline 133
	inc [X+1]
	.dbline 134
	mov [X+2],0
	.dbline 135
L18:
	.dbline 117
	mov A,0
	cmp A,[X-8]
	jc L17
X3:
	.dbline 137
; 			
; 		// -- prepare for next block to modify
; 		src      += WrLength;  
; 		length   -= WrLength;
; 		FlashBlk++;
; 		BlkOffset = 0;
; 	}
; 	
; 	return 1;
	mov REG[0xd0],>__r0
	mov A,1
	.dbline -2
L13:
	add SP,-6
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l Temperature 5 c
	.dbsym l FlashBlk_End 4 c
	.dbsym l Result 3 c
	.dbsym l BlkOffset 2 c
	.dbsym l FlashBlk 1 c
	.dbsym l WrLength 0 c
	.dbsym l length -8 c
	.dbsym l src -7 pc
	.dbsym l dest -5 pc
	.dbend
	.area data(ram, con, rel)
	.dbfile ./nonvolatile.c
_frStruct::
	.byte 0,0,0,0,0,0
	.dbsym e frStruct _frStruct X
	.area data(ram, con, rel)
	.dbfile ./nonvolatile.c
_fwStruct::
	.byte 0,0,0,0,0,0,0,0
	.dbsym e fwStruct _fwStruct X
	.area data(ram, con, rel)
	.dbfile ./nonvolatile.c
_RWBuf::
	.word 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0
	.dbsym e RWBuf _RWBuf A[66:66]c
